---
title: List User Groups
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[IAM](https://developers.cloudflare.com/api/go/resources/iam)

[User Groups](https://developers.cloudflare.com/api/go/resources/iam/subresources/user_groups)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# List User Groups

client.IAM.UserGroups.List(ctx, params) (\*V4PagePaginationArray\[[UserGroupListResponse](<https://developers.cloudflare.com/api/go/resources/iam#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)>)], error)

GET/accounts/{account\_id}/iam/user\_groups

List all the user groups for an account.

##### Security

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`SCIM Provisioning``Account Settings Write``Account Settings Read`

##### ParametersExpand Collapse

<details>

<summary>

params UserGroupListParams

</summary>

AccountID param.Field\[string]

Path param: Account identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

ID param.Field\[string]Optional

Query param: ID of the user group to be fetched.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20id">Link to this property</a>

<details>

<summary>

Direction param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/iam/subresources/user_groups/methods/list#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)">UserGroupListParamsDirection</a>]Optional

Query param: The sort order of returned user groups by name (ascending or descending).

</summary>

const UserGroupListParamsDirectionAsc <a href="https://developers.cloudflare.com/api/go/resources/iam/subresources/user_groups/methods/list#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)">UserGroupListParamsDirection</a> = "asc"

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const UserGroupListParamsDirectionDesc <a href="https://developers.cloudflare.com/api/go/resources/iam/subresources/user_groups/methods/list#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)">UserGroupListParamsDirection</a> = "desc"

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction">Link to this property</a>

FuzzyName param.Field\[string]Optional

Query param: A string used for searching for user groups containing that substring.

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20fuzzyName">Link to this property</a>

Name param.Field\[string]Optional

Query param: Name of the user group to be fetched.

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20name">Link to this property</a>

Page param.Field\[float64]Optional

Query param: Page number of paginated results.

minimum1

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20page">Link to this property</a>

PerPage param.Field\[float64]Optional

Query param: Maximum number of results per page.

maximum500

minimum1

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20per_page">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.user_groups%20%3E%20(method)%20list%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type UserGroupListResponse struct{…}

A group of policies resources.

</summary>

ID string

User Group identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

CreatedOn Time

Timestamp for the creation of the user group

formatdate-time

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

ModifiedOn Time

Last time the user group was modified.

formatdate-time

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

Name string

Name of the user group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

<details>

<summary>

Policies \[]UserGroupListResponsePolicyOptional

Policies attached to the User group

</summary>

ID stringOptional

Policy identifier.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Access UserGroupListResponsePoliciesAccessOptional

Allow or deny operations against the resources.

</summary>

One of the following:

const UserGroupListResponsePoliciesAccessAllow UserGroupListResponsePoliciesAccess = "allow"

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20access%20%3E%20(member)%200">Link to this property</a>

const UserGroupListResponsePoliciesAccessDeny UserGroupListResponsePoliciesAccess = "deny"

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20access%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20access">Link to this property</a>

<details>

<summary>

PermissionGroups \[]UserGroupListResponsePoliciesPermissionGroupOptional

A set of permission groups that are specified to the policy.

</summary>

ID string

Identifier of the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Meta UserGroupListResponsePoliciesPermissionGroupsMetaOptional

Attributes associated to the permission group.

</summary>

Category stringOptional

A category used to group permission groups.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20category">Link to this property</a>

Deprecated stringOptional

Indicates whether the permission group is deprecated.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20deprecated">Link to this property</a>

Description stringOptional

Additional information about the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20description">Link to this property</a>

Editable stringOptional

Indicates whether the permission group can be edited.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20editable">Link to this property</a>

EolAt TimeOptional

The planned end-of-life date and time, when provided.

formatdate-time

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20eol_at">Link to this property</a>

Label stringOptional

A label identifying the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20label">Link to this property</a>

Scopes stringOptional

The scope associated with the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20scopes">Link to this property</a>

Visibility stringOptional

Indicates the permission group’s availability or visibility.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20visibility">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta">Link to this property</a>

Name stringOptional

Name of the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20name">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups">Link to this property</a>

<details>

<summary>

ResourceGroups \[]UserGroupListResponsePoliciesResourceGroupOptional

A list of resource groups that the policy applies to.

</summary>

ID string

Identifier of the resource group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Scope UserGroupListResponsePoliciesResourceGroupsScope

A scope is a combination of scope objects which provides additional context.

</summary>

Key string

This is a combination of pre-defined resource name and identifier (like Account ID etc.)

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope%20%3E%20(property)%20key">Link to this property</a>

<details>

<summary>

Objects \[]UserGroupListResponsePoliciesResourceGroupsScopeObject

A list of scope objects for additional context.

</summary>

Key string

This is a combination of pre-defined resource name and identifier (like Zone ID etc.)

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope%20%3E%20(property)%20objects%20%3E%20(items)%20%3E%20(property)%20key">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope%20%3E%20(property)%20objects">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope">Link to this property</a>

<details>

<summary>

Meta UserGroupListResponsePoliciesResourceGroupsMetaOptional

Attributes associated to the resource group.

</summary>

Key stringOptional

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20key">Link to this property</a>

Value stringOptional

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20meta">Link to this property</a>

Name stringOptional

Name of the resource group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20name">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)%20%3E%20(property)%20policies">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupListResponse%20%3E%20(schema)>)

### List User Groups

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/iam"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"),
    option.WithAPIEmail("user@example.com"),
  )
  page, err := client.IAM.UserGroups.List(context.TODO(), iam.UserGroupListParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "023e105f4ecef8ad9ca31a8372d0c353",
      "created_on": "2024-03-01T12:21:02Z",
      "modified_on": "2024-03-01T12:21:02Z",
      "name": "My New User Group",
      "policies": [
        {
          "id": "f267e341f3dd4697bd3b9f71dd96247f",
          "access": "allow",
          "permission_groups": [
            {
              "id": "c8fed203ed3043cba015a93ad1616f1f",
              "meta": {
                "category": "category",
                "deprecated": "deprecated",
                "description": "description",
                "editable": "editable",
                "eol_at": "2019-12-27T18:11:19.117Z",
                "label": "load_balancer_admin",
                "scopes": "com.cloudflare.api.account",
                "visibility": "visibility"
              },
              "name": "Zone Read"
            },
            {
              "id": "82e64a83756745bbbb1c9c2701bf816b",
              "meta": {
                "category": "category",
                "deprecated": "deprecated",
                "description": "description",
                "editable": "editable",
                "eol_at": "2019-12-27T18:11:19.117Z",
                "label": "fbm_user",
                "scopes": "com.cloudflare.api.account",
                "visibility": "visibility"
              },
              "name": "Magic Network Monitoring"
            }
          ],
          "resource_groups": [
            {
              "id": "6d7f2f5f5b1d4a0e9081fdc98d432fd1",
              "scope": {
                "key": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4",
                "objects": [
                  {
                    "key": "com.cloudflare.api.account.zone.23f8d65290b24279ba6f44721b3eaad5"
                  }
                ]
              },
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4"
            }
          ]
        }
      ]
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "023e105f4ecef8ad9ca31a8372d0c353",
      "created_on": "2024-03-01T12:21:02Z",
      "modified_on": "2024-03-01T12:21:02Z",
      "name": "My New User Group",
      "policies": [
        {
          "id": "f267e341f3dd4697bd3b9f71dd96247f",
          "access": "allow",
          "permission_groups": [
            {
              "id": "c8fed203ed3043cba015a93ad1616f1f",
              "meta": {
                "category": "category",
                "deprecated": "deprecated",
                "description": "description",
                "editable": "editable",
                "eol_at": "2019-12-27T18:11:19.117Z",
                "label": "load_balancer_admin",
                "scopes": "com.cloudflare.api.account",
                "visibility": "visibility"
              },
              "name": "Zone Read"
            },
            {
              "id": "82e64a83756745bbbb1c9c2701bf816b",
              "meta": {
                "category": "category",
                "deprecated": "deprecated",
                "description": "description",
                "editable": "editable",
                "eol_at": "2019-12-27T18:11:19.117Z",
                "label": "fbm_user",
                "scopes": "com.cloudflare.api.account",
                "visibility": "visibility"
              },
              "name": "Magic Network Monitoring"
            }
          ],
          "resource_groups": [
            {
              "id": "6d7f2f5f5b1d4a0e9081fdc98d432fd1",
              "scope": {
                "key": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4",
                "objects": [
                  {
                    "key": "com.cloudflare.api.account.zone.23f8d65290b24279ba6f44721b3eaad5"
                  }
                ]
              },
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4"
            }
          ]
        }
      ]
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```